"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var flattenErrorCauses_exports = {};
__export(flattenErrorCauses_exports, {
  compareTraceFragments: () => compareTraceFragments,
  compareTraces: () => compareTraces,
  flattenCausesTransformer: () => flattenCausesTransformer,
  mergeTraceHeads: () => mergeTraceHeads
});
module.exports = __toCommonJS(flattenErrorCauses_exports);
var import_lodash = __toESM(require("@modern-js/utils/lodash"));
const compareTraces = (trace1, trace2) => {
  if (trace1.length !== trace2.length) {
    return false;
  }
  for (let i = 0; i < trace1.length; i++) {
    const s1 = trace1[i];
    const s2 = trace2[i];
    if (s1.file !== s2.file || s1.line !== s2.line || s1.column !== s2.column) {
      return false;
    }
  }
  return true;
};
const compareTraceFragments = (trace1, trace2) => {
  const len = Math.min(trace1.length, trace2.length);
  return compareTraces(trace1.length === len ? trace1 : trace1.slice(0, len), trace2.length === len ? trace2 : trace2.slice(0, len));
};
const mergeTraceHeads = (traces) => {
  const heads = [];
  const tails = [];
  for (const [head, ...rest] of traces) {
    if (!heads.length) {
      heads.push(head);
      tails.push(...rest);
    } else if (compareTraceFragments(tails, rest)) {
      heads.push(head);
    } else {
      return null;
    }
  }
  return [
    ...heads,
    ...tails
  ];
};
const flattenCausesTransformer = (e) => {
  const traces = [
    e.trace,
    ...import_lodash.default.map(e.causes, "trace")
  ];
  const merged = mergeTraceHeads(traces);
  if (merged) {
    e.trace = merged;
    e.causes = [];
  }
  return e;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  compareTraceFragments,
  compareTraces,
  flattenCausesTransformer,
  mergeTraceHeads
});
